% \documentclass[noanswers, nolegalese, 11pt]{examjh}
\documentclass[answers, nolegalese, 11pt]{examjh}
\usepackage{../../../../computingfonts}
\usepackage{../../../../contentmacros}
\usepackage{graphicx}

\setlength{\parindent}{0em}\setlength{\parskip}{0.5ex}
\pagestyle{empty}
\begin{document}\thispagestyle{empty}
\makebox[\textwidth]{Questions for Four.I\hfill  From \textit{Theory of Computation}, by Hef{}feron}\vspace{-1ex}
\makebox[\textwidth]{\hbox{}\hrulefill\hbox{}}


\begin{questions}
\question
For each language, name five strings in the language and five that are not.
The alphabet is $\Sigma=\set{\str{a}, \str{b}}$.
Then design a Finite State machine 
that will recognize the language, 
giving a one-sentence English description of each state.
Draw a circle graph and a table for the transition function.
\begin{parts}
\part
$\lang_1=\set{\sigma\in\kleenestar{\Sigma}\suchthat
               \text{$\sigma$ has at least one \str{a} and at least one \str{b}}}$
\begin{solution}
Five members are \str{ab}, \str{baab}, \str{ba}, 
$\str{b}^7\str{a}^3$, and $\str{a}\str{b}^6\str{a}$.
Five nonmembers are 
\str{aaaa}, \str{bbbb}, \str{a}, \emptystring, and \str{b}.
We take the meaning of the states to be as here.
\begin{center}
\begin{tabular}{r|l}
  \textit{State}  &\textit{Description}  \\
  \hline
  $q_0$  &start state  \\  
  $q_1$  &have seen at least one \str{a}, no \str{b}'s   \\
  $q_2$  &have seen at least one \str{b}, no \str{a}'s   \\
  $q_3$  &at least one of each  \\
\end{tabular}
\end{center}
The drawing is this.
\begin{center}
  \vcenteredhbox{\includegraphics{asy/automata000.pdf}}
\end{center}
This tabular presentation of the transition function is completely eqivalent to
the drawing.  
\begin{center}
\begin{tabular}{r|cc}
   \multicolumn{1}{r}{$\Delta$} 
     &\multicolumn{1}{c}{\str{a}} 
     &\multicolumn{1}{c}{\str{b}}   \\
   \cline{2-3} 
   $q_0$  &$q_1$  &$q_2$  \\
   $q_1$  &$q_1$  &$q_3$  \\
   $q_2$  &$q_3$  &$q_2$  \\
  +$q_3$  &$q_3$  &$q_3$  \\
\end{tabular}
\end{center}
\end{solution}

\part
$\lang_2=\set{\sigma\in\kleenestar{\Sigma}\suchthat
               \text{$\sigma$ has fewer than three \str{a}'s}}$
\begin{solution}
Five members are: \str{bb}, \emptystring, \str{aba}, \str{a}, 
and $\str{bbb}\str{aa}\str{b}$.
Five nonmembers are 
\str{aaa}, \str{baaa}, $\str{a}^5$, \srt{bababa}, and $\str{a}^{10}$.
We take the states with this meaning.
\begin{center}
\begin{tabular}{r|l}
  \textit{State}  &\textit{Description}  \\
  \hline
  $q_0$  &start state, no \str{a}'s seen yet  \\  
  $q_1$  &have seen one \str{a}, and maybe some number of \str{b}'s   \\
  $q_2$  &have seen two \str{a}'s   \\
  $q_3$  &have seen three or more \str{a}'s  \\
\end{tabular}
\end{center}
This is the circle drawing presentation of the transition function.
\begin{center}
  \vcenteredhbox{\includegraphics{asy/automata001.pdf}}
\end{center}
This is the tabular presentation.  
\begin{center}
\begin{tabular}{r|cc}
   \multicolumn{1}{r}{$\Delta$} 
     &\multicolumn{1}{c}{\str{a}} 
     &\multicolumn{1}{c}{\str{b}}   \\
   \cline{2-3} 
  +$q_0$  &$q_1$  &$q_0$  \\
  +$q_1$  &$q_2$  &$q_1$  \\
  +$q_2$  &$q_3$  &$q_2$  \\
   $q_3$  &$q_3$  &$q_3$  \\
\end{tabular}
\end{center}
\end{solution}

\part
$\lang_3=\set{\sigma\in\kleenestar{\Sigma}\suchthat
               \text{$\sigma$ ends in \str{ab}}}$
\begin{solution}
Five members are \str{ab}, \str{bab}, \str{aab}, \str{baab}, 
and \str{abab}.
Five nonmembers: 
\str{a}, \str{bbb}, \emptysrtring, \srt{b}, and \str{abababb}.
We use the states with this meaning.
\begin{center}
\begin{tabular}{r|l}
  \textit{State}  &\textit{Description}  \\
  \hline
  $q_0$  &start state, have not just seen an \str{a}  \\  
  $q_1$  &have seen an \str{a}, waiting for a \str{b}'s   \\
  $q_2$  &have just seen \str{ab}   \\
\end{tabular}
\end{center}
This is the circle presentation of the transition function.
\begin{center}
  \vcenteredhbox{\includegraphics{asy/automata002.pdf}}
\end{center}
This is the tabular presentation.  
\begin{center}
\begin{tabular}{r|cc}
   \multicolumn{1}{r}{$\Delta$} 
     &\multicolumn{1}{c}{\str{a}} 
     &\multicolumn{1}{c}{\str{b}}   \\
   \cline{2-3} 
   $q_0$  &$q_1$  &$q_0$  \\
   $q_1$  &$q_1$  &$q_2$  \\
  +$q_2$  &$q_1$  &$q_0$  \\
\end{tabular}
\end{center}
\end{solution}

\part
$\lang_4=\set{\str{a}^n\str{b}^m\in\kleenestar{\Sigma}\suchthat
               n,m\geq 2}$
\begin{solution}
Five members are \str{aabb}, \str{aaabb}, \str{aabbb}, $\str{a}^7\str{b}^9$,  
and $\str{a}^2\str{b}^{200}$.
Five nonmembers are
\emptystring, \str{a}, \str{ab}, \srt{ba}, and~\str{b}.
We use the states with this meaning.
\begin{center}
\begin{tabular}{r|l}
  \textit{State}  &\textit{Description}  \\
  \hline
  $q_0$  &start state, have not just seen anything  \\  
  $q_1$  &have seen one character, an \str{a}   \\
  $q_2$  &have seen at least two \str{a}'s   \\
  $q_3$  &have seen at least two \str{a}'s and one \str{b}  \\
  $q_4$  &have seen at least two \str{a}'s and at least two \str{b}'s   \\
  $q_5=e$&error   \\
\end{tabular}
\end{center}
This is the transition function's circle drawing.
\begin{center}
  \vcenteredhbox{\includegraphics{asy/automata003.pdf}}
\end{center}
This is the tabular presentation.  
\begin{center}
\begin{tabular}{r|cc}
   \multicolumn{1}{r}{$\Delta$} 
     &\multicolumn{1}{c}{\str{a}} 
     &\multicolumn{1}{c}{\str{b}}   \\
   \cline{2-3} 
   $q_0$  &$q_1$  &$e$  \\
   $q_1$  &$q_2$  &$e$  \\
   $q_2$  &$q_2$  &$q_3$  \\
   $q_3$  &$e$    &$q_4$  \\
  +$q_4$  &$e$    &$q_4$  \\
   $e$    &$e$    &$e$  \\
\end{tabular}
\end{center}
\end{solution}

\part
$\lang_5=\set{\str{a}^n\str{b}^m\str{a}^p\in\kleenestar{\Sigma}\suchthat
               m=2}$
\begin{solution}
Five members are \str{aabba}, \str{aabb}, \str{abb}, \str{bb},  
and $\str{a}^5\str{bb}^{7}$.
Five nonmembers are
\emptystring, \str{bab}, \str{aabaa}, \srt{aabbbaa}, and~\str{aabbaab}.
We take the states with this meaning.
\begin{center}
\begin{tabular}{r|l}
  \textit{State}  &\textit{Description}  \\
  \hline
  $q_0$  &have so far seen some number of \str{a}'s, including zero-many  \\  
  $q_1$  &have seen some \str{a}'s followed by one \str{b}   \\
  $q_2$  &seen some \str{a}'s, two \str{b}'s, and some \str{a}'s   \\
  $e$    &error   \\
\end{tabular}
\end{center}
This is the circle drawing
\begin{center}
  \vcenteredhbox{\includegraphics{asy/automata004.pdf}}
\end{center}
and this is the tabular presentation.  
\begin{center}
\begin{tabular}{r|cc}
   \multicolumn{1}{r}{$\Delta$} 
     &\multicolumn{1}{c}{\str{a}} 
     &\multicolumn{1}{c}{\str{b}}   \\
   \cline{2-3} 
   $q_0$  &$q_0$  &$q_1$  \\
   $q_1$  &$e$    &$q_2$  \\
  +$q_2$  &$q_2$  &$e$  \\
   $e$    &$e$    &$e$  \\
\end{tabular}
\end{center}
\end{solution}
\end{parts}


\question
Give a Finite State machine that accepts this language.
\begin{equation*}
  \set{\sigma\in\kleenestar{\set{\str{0},\ldots \str{9}}}\suchthat
             \text{$\sigma$ represents a multiple of $5$ in base~$10$}}
\end{equation*}
\begin{solution}
\begin{center}
  \vcenteredhbox{\includegraphics{asy/automata005.pdf}}
\end{center}
\end{solution}

\end{questions}
\end{document}
